Package org.apache.commons.lang3.concurrent

## Enum AbstractCircuitBreaker.State

- java.lang.Object
- - java.lang.Enum<AbstractCircuitBreaker.State>
  - - org.apache.commons.lang3.concurrent.AbstractCircuitBreaker.State

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.Comparable<AbstractCircuitBreaker.State>`

Enclosing class:
  AbstractCircuitBreaker<T>

    protected static enum AbstractCircuitBreaker.State
    extends java.lang.Enum<AbstractCircuitBreaker.State>

An internal enumeration representing the different states of a circuit breaker. This class also contains some logic for performing state transitions. This is done to avoid complex if-conditions in the code of `CircuitBreaker`.

### Enum Constant Summary

Enum Constants
`CLOSED`
`OPEN`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`abstract AbstractCircuitBreaker.State` `oppositeState()` Returns the opposite state to the represented state.
`static AbstractCircuitBreaker.State` `valueOf​(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static AbstractCircuitBreaker.State[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### CLOSED

    public static final AbstractCircuitBreaker.State CLOSED

#### OPEN

    public static final AbstractCircuitBreaker.State OPEN

### Method Detail

#### values

    public static AbstractCircuitBreaker.State[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (AbstractCircuitBreaker.State c : AbstractCircuitBreaker.State.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static AbstractCircuitBreaker.State valueOf​(java.lang.String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null

#### oppositeState

    public abstract AbstractCircuitBreaker.State oppositeState()

Returns the opposite state to the represented state. This is useful for flipping the current state.

Returns:
  the opposite state